unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, IdBaseComponent, IdComponent, IdTCPConnection, IdTCPClient,
  ActnList, Menus, ThreadsLift, ComCtrls;

type
  TForm1 = class(TForm)
    client: TIdTCPClient;
    mmnMain: TMainMenu;
    mniNetworkMenu: TMenuItem;
    mniNetworkConnect: TMenuItem;
    aclMain: TActionList;
    aclNetworkConnect: TAction;
    aclNetworkDisconnect: TAction;
    mniNetworkDisconnect: TMenuItem;
    stbMain: TStatusBar;
    lsvLog: TListView;
    procedure aclNetworkConnectUpdate(Sender: TObject);
    procedure aclNetworkConnectExecute(Sender: TObject);
    procedure aclNetworkDisconnectUpdate(Sender: TObject);
    procedure aclNetworkDisconnectExecute(Sender: TObject);
    procedure clientConnected(Sender: TObject);
    procedure clientDisconnected(Sender: TObject);
  private
    thread: TLiftThread;
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.aclNetworkConnectUpdate(Sender: TObject);
begin
  aclNetworkConnect.Enabled := not client.Connected();
end;

procedure TForm1.aclNetworkConnectExecute(Sender: TObject);
var
  host: string;
begin
  stbMain.SimpleText := 'Connecting...';

  host := client.Host;
  InputQuery('Host address', 'Enter the host''s address:' , host);
  client.host := host;
  Application.ProcessMessages;

  try
    client.Connect();

    // Activate the IO thread...
    thread := TLiftThread.Create(True);
    thread.client := client;
    thread.log := lsvLog;
    thread.FreeOnTerminate := True;
    thread.Resume();

  except
    stbMain.SimpleText := 'Ready';
    raise;
  end;
end;

procedure TForm1.aclNetworkDisconnectUpdate(Sender: TObject);
begin
  aclNetworkDisconnect.Enabled := client.Connected;
end;

procedure TForm1.aclNetworkDisconnectExecute(Sender: TObject);
begin
  client.Disconnect;
end;

procedure TForm1.clientConnected(Sender: TObject);
begin
  stbMain.SimpleText := 'Connected';
end;

procedure TForm1.clientDisconnected(Sender: TObject);
begin
  stbMain.SimpleText := 'Disconnected';
end;

end.
